require ("_prolog")
require ("_opencv")
function main()
  if (not OcvEnabled) then
     error(errOcvDisabled)  
     return     
  end         
  -- target images must be loaded
  if (TargetImage.Plane == nil) then
      error(errTargetEmpty)
      return
  end    
  -- source mask moust be loaded
  if (SourceMask.Plane == nil) then
      error("Error: source mask is empty!")
      return
  end     
  local sMask = lips_CreateImage("grayscale", SourceMask.Width, SourceMask.Height)    
  lips_CopyImage(SourceMask, sMask)      
  -- set OpenCV src/tgt images
  ocv_SetImage("source", SourceImage)
  ocv_SetImage("srcmask",sMask)
  ocv_SetImage("target", TargetImage) 
  local params
  if SilentParams ~= nil then
     params = SilentParams
  else
     params = "0, 3.0"
  end
  ocv_Process("Inpaint", params)   
end
