require ("_prolog")
require ("_opencv")
function main()
  if (not OcvEnabled) then
     error(errOcvDisabled)  
     return     
  end         
  -- target images must be loaded
  if (TargetImage.Plane == nil) then
      error(errTargetEmpty)
      return
  end    
  if TargetRoi == nil or CustomImage.Plane == nil  then
     error("Target roi empty.")  
     return
  end
  local sImage = CustomImage
  local sMask  = CustomMask 
  -- set OpenCV src/tgt images
  ocv_SetImage("source", sImage)
  ocv_SetImage("srcmask", sMask)
  ocv_SetImage("target", TargetImage) 
  if (TargetRoi.Left < 0 or TargetRoi.Right > TargetImage.Width or TargetRoi.Top < 0 or TargetRoi.Bottom > TargetImage.Height) then
      error("Target roi invalid boundaries.")
      return
  end    
  local centerX = math.floor(TargetRoi.Left + (TargetRoi.Right - TargetRoi.Left)/2)     
  local centerY = math.floor(TargetRoi.Top + (TargetRoi.Bottom - TargetRoi.Top)/2)  
  local scType = 1
  if SilentParams ~= nil then
     scType = tonumber(SilentParams)  -- there should be only one parameter
  end
  -- OpenCV Mat is upside-down, so let's adjust centerY value
  centerY = TargetImage.Height - 1 - centerY
  local params = tostring(centerX)..", "..tostring(centerY)..", "..tostring(scType)
  ocv_Process("SeamlessClone", params)   
end
