require ("_prolog")
require ("_opencv")
function RequireParams()  
   lips_RequireParams("result_as_new_image = bool([] true); selection_roi = bool([] true);")
end   
function main()
  if (not OcvEnabled) then
     lips_SendMessage(errOcvDisabled) 
     return     
  end     
  if (TargetImage.Plane == nil) then
      lips_SendMessage(errTargetEmpty)
      return
  end      
  local params = tostring(result_as_new_image)
  lips_SendCommand("selection", "DisableRoi")   -- disable selection roi for post-processing   
  -- set OpenCV src/tgt images
  ocv_SetImage("source", SourceImage)
  ocv_SetImage("target", TargetImage)   
  if selection_roi then   
     ocv_SetRoi("source", SourceRoi)
  end
  -- perform color transfer
  lips_SendMessage("Applying color transfer.")  
  ocv_Process("ColorTransfer", params)
  if (result_as_new_image) then
     ocv_FlipExport()   -- because image is upside down in OpenCV  
     local id = ocv_GetLastImageId()    
     local outImage = lips_GetImageFromId(id)
     lips_ExportImage(outImage, "color transfer")
  end  
end
